## Index

### Classes

- AbstractNode
- AbstractVisitor
- Annotation
- AnnotationDefinition
- Argument
- BaseVisitor
- BooleanValue
- Context
- Document
- EnumDefinition
- EnumValue
- EnumValueDefinition
- FieldDefinition
- FloatValue
- InputValueDefinition
- IntValue
- InterfaceDefinition
- List
- ListValue
- Location
- Map
- MapValue
- Name
- Named
- NamespaceDefinition
- ObjectDefinition
- ObjectField
- ObjectValue
- OperationDefinition
- Optional
- RoleDefinition
- Source
- StringValue
- Token
- UnionDefinition
- ValuedDefinition
- Variable
- Writer

### Interfaces

- Definition
- DescribableNode
- Node
- Type
- TypeDefinition
- TypeSystemDefinition
- Value
- Visitor

### Type aliases

- Callbacks
- NodeArray
- ObjectMap
- ParseOptions
- VisitorCallback

### Variables

- kinds

### Functions

- parse
- parseValue

## Type aliases

### Callbacks

Callbacks: Map<string, Map<string, VisitorCallback>>

- Defined in src/ast/visitor.ts:233

### NodeArray

NodeArray: Node[]

- Defined in src/ast/node.ts:10

### ObjectMap

ObjectMap<T>: {}

- Defined in src/ast/visitor.ts:30

#### Type parameters

- #### T = any

#### Type declaration

- ##### [key: string]: T

### ParseOptions

ParseOptions: { noLocation: boolean; noSource: boolean }

- Defined in src/parser.ts:47

Configuration options to control parser behavior

#### Type declaration

- ##### noLocation: boolean

  By default, the parser creates AST nodes that know the location in the source that they correspond to. This configuration flag disables that behavior for performance or testing.

- ##### noSource: boolean

### VisitorCallback

VisitorCallback: (_context: Context) => void

- Defined in src/ast/visitor.ts:234

#### Type declaration

- - (_context: Context): void

  - #### Parameters

    - ##### _context: Context

    #### Returns void

## Variables

### Const kinds

kinds: { Annotation: string; AnnotationDefinition: string; Argument: string; BooleanValue: string; Document: string; EnumDefinition: string; EnumValue: string; EnumValueDefinition: string; Field: string; FieldDefinition: string; FloatValue: string; InputValueDefinition: string; IntValue: string; InterfaceDefinition: string; List: string; ListValue: string; Map: string; MapValue: string; Name: string; Named: string; NamespaceDefinition: string; ObjectDefinition: string; ObjectField: string; ObjectValue: string; OperationDefinition: string; OperationTypeDefinition: string; Optional: string; RoleDefinition: string; ScalarDefinition: string; SchemaDefinition: string; SelectionSet: string; StringValue: string; UnionDefinition: string; Variable: string; VariableDefinition: string } = ...

- Defined in src/ast/kinds.ts:1

#### Type declaration

- ##### Annotation: string

- ##### AnnotationDefinition: string

- ##### Argument: string

- ##### BooleanValue: string

- ##### Document: string

- ##### EnumDefinition: string

- ##### EnumValue: string

- ##### EnumValueDefinition: string

- ##### Field: string

- ##### FieldDefinition: string

- ##### FloatValue: string

- ##### InputValueDefinition: string

- ##### IntValue: string

- ##### InterfaceDefinition: string

- ##### List: string

- ##### ListValue: string

- ##### Map: string

- ##### MapValue: string

- ##### Name: string

- ##### Named: string

- ##### NamespaceDefinition: string

- ##### ObjectDefinition: string

- ##### ObjectField: string

- ##### ObjectValue: string

- ##### OperationDefinition: string

- ##### OperationTypeDefinition: string

- ##### Optional: string

- ##### RoleDefinition: string

- ##### ScalarDefinition: string

- ##### SchemaDefinition: string

- ##### SelectionSet: string

- ##### StringValue: string

- ##### UnionDefinition: string

- ##### Variable: string

- ##### VariableDefinition: string

## Functions

### parse

- parse(source: string, options?: ParseOptions): Document

- - Defined in src/parser.ts:62

  Given a WIDL source, parses it into a Document. Throws WidlError if a syntax error is encountered.

  #### Parameters

  - ##### source: string

  - ##### Optional options: ParseOptions

  #### Returns Document

### parseValue

- parseValue(source: string, options?: ParseOptions): Value

- - Defined in src/parser.ts:77

  Given a string containing a WIDL value (ex. `[42]`), parse the AST for that value. Throws WidlError if a syntax error is encountered.

  This is useful within tools that operate upon WIDL Values directly and in isolation of complete WIDL documents.

  Consider providing the results to the utility function: valueFromAST().

  #### Parameters

  - ##### source: string

  - ##### Optional options: ParseOptions

  #### Returns Value

Generated using TypeDoc